
-- hump Gamestate module
-- http://vrld.github.com/hump/#gamestate.lua
require("hump/gamestate.lua")

-- create new gamestate
learnGamestate = Gamestate.new()

-- Called when switching to learnGamestate
function learnGamestate:enter(previous)
  menu =
      "This is the gamestate module example.\n\n" ..
      
      "Escape exits or returns to this menu.\n\n" ..
      
      "Press the corresponding number to see other hump modules.\n" ..
      "1. Timer\n" ..
      "2. Vector\n" ..
      "3. Class\n" ..
      "4. Camera\n" ..
      "5. Ringbuffer\n" ..
      "6. Sequence\n"
end

-- Should be used as love.update
function learnGamestate:update(dt)
  
end

-- Should be used as love.draw
function learnGamestate:draw()
  love.graphics.print(menu,10,10)
end

-- This and other auxiliary love callbacks availible
-- http://vrld.github.com/hump/#gamestate.lua-callbackList
function learnGamestate:keypressed(key)
  if key=='1' then
    Gamestate.switch(learnTimer)
  elseif key=='2' then
    Gamestate.switch(learnVector)
  elseif key=='3' then
    Gamestate.switch(learnClass)
  else
    love.event.push('q')
  end
end

-- Called when leaving learnGamestate
function learnGamestate:leave()
  -- Consider making your globals nil so they are garbage collected.
  menu = nil
end
