
-- hump Vector module
-- http://vrld.github.com/hump/#vector.lua
require("hump/vector.lua")

learnVector = Gamestate.new()

function learnVector:enter(previous)
  local a = vector(1,1)
  local b = vector(0,1)
  local c = vector(2,1)
  text = "This is the vector module example.\n\n" ..
    
    "Escape returns to the menu.\n\n" ..
    
    "Vectors: a, b, c\n" ..
    "isvector(a): " .. tostring(isvector(a)) .. "\n" ..
    "isvector({1,2}): " .. tostring(isvector({1,2})) .. "\n" ..
    "clone(a): (" .. table.concat({a:clone():unpack()},",") .. ")\n" ..
    "Unpack: (" ..
    table.concat({a:unpack()},",") .. "), (" ..
    table.concat({b:unpack()},",") .. "), (" ..
    table.concat({c:unpack()},",") .. ")\n" ..
    "Operators:\n" ..
    "  a+b: " .. table.concat({(a+b):unpack()},",") .. "\n" ..
    "  a-b: " .. table.concat({(a-b):unpack()},",") .. "\n" ..
    "  -a: " .. table.concat({(-a):unpack()},",") .. "\n" ..
    "  a*2: " .. table.concat({(a*2):unpack()},",") .. "\n" ..
    "  a*b: " .. (a*b) .. "\n" ..
    "  a/2: " .. table.concat({(a/2):unpack()},",") .. "\n" ..
    "  a<=b: " .. tostring(a<=b) .. "\n" ..
    "  a<b: " .. tostring(a<b) .. "\n" ..
    "  a>=b: " .. tostring(a>=b) .. "\n" ..
    "  a>b: " .. tostring(a>b) .. "\n" ..
    "a:permul(c): (" .. table.concat({a:permul(c):unpack()},",") .. ")\n" ..
    "a:len(): " .. a:len() .. "\n" ..
    "a:len2(): " .. a:len2() .. "\n" ..
    "a:dist(b): " .. a:dist(b) .. "\n" ..
    "a:normalized(): (" .. table.concat({a:normalized():unpack()},",") .. ")\n" ..
    "a:rotated(math.pi): (" .. table.concat({a:rotated(math.pi):unpack()},",") .. ")\n" ..
    "a:perpendicular(): (" .. table.concat({a:perpendicular():unpack()},",") .. ")\n" ..
    "a:projectOn(b): (" .. table.concat({a:projectOn(c):unpack()},",") .. ")\n" ..
    "a:cross(b): (" .. a:cross(c) .. ")\n" ..
    ""
end

function learnVector:update(dt)
  
end

function learnVector.draw()
  love.graphics.print(text,10,10)
end

function learnVector:keypressed(key)
  if key=='escape' then
    Gamestate.switch(learnGamestate)
  end
end

function learnVector:leave()
  text = nil
end
